<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Flow Control</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

		<div class="reveal">
			<div class="slides">
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h1>Control Flow</h1>
					</section>
					<section>
						<h2>Control Flow Overview</h2>
						<ul>
                            <li>
                                <b>Operators</b>
                                <ul>
                                    <li>Membership Operators</li>
                                    <li>Identity Operators</li>
                                    <li>Boolean Operators</li>
                                    <li>Assignment Operators</li>
                                </ul>
                            </li>
                            <li>
                                <b>I/O: Print</b>
                                <ul>
                                    <li>% Formatting</li>
                                    <li>format()</li>
                                </ul>
                            </li>
                        </ul>
                    </section>
                    <section>
                        <h2>Overview (Cont.)</h2>
                        <ul>
                            <li>
                                <b>I/O: Files</b>
                                <ul>
                                    <li>
                                        open() Operation Arguments
                                        <ul>
                                            <li>read</li>
                                            <li>write</li>
                                            <li>append</li>
                                        </ul>
                                    </li>
                                    <li>File Operator</li>
                                </ul>
                            </li>
							<li><b>If, Elif, Else</b></li>
                        </ul>
                    </section>
                    <section>
                        <h2>Overview (Cont.)</h2>
                        <ul>
                            <li>
                                <b>While Loops</b>
                                <ul>
                                    <li>While Else</li>
                                </ul>
                            </li>
							<li>
                                <b>For Loops</b>
                                <ul>
                                    <li>For Looping Dictionaries</li>
                                </ul>
                            </li>
							<li><b>Break and Continue</b></li>
                        </ul>
                    </section>
                    <section>
                        <h2>Objectives</h2>
                        <a href="../objectives.html" target="_blank">Flow Control Objectives</a>
                    </section>
					<section>
						<h2>By the end of this lesson you should know:</h2>
						<ul>
							<li>How to use comparison operators</li>
							<li>When, why and how if, elif and else statements are used</li>
							<li>When, why and how to use while and for loops</li>
							<li>How to break and continue</li>
							<li>How to use old and new style formatting</li>
							<li>How to modify files</li>
						</ul>
					</section>		
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Operators</h2>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Comparison Operators</h3>
						<ul>
							<li><b>x == y</b>
								<ul>
									<li style="font-size: 24px;">if x equals y, return True​</li>
								</ul>
							</li>
							<li><b>x != y</b>
								<ul>
									<li style="font-size: 24px;">if x is not y, return True​</li>
								</ul>
							</li>
							<li><b>x &gt; y</b>
								<ul>
									<li style="font-size: 24px;">if x is greater than y, return True​</li>
								</ul>
							</li>
							<li><b>x &lt; y</b>
								<ul>
									<li style="font-size: 24px;">if x is less than y, return True​</li>
								</ul>
							</li>
							<li><b>x &gt;= y</b>
								<ul>
									<li style="font-size: 24px;">if x is greater or equal to y, return True​</li>
								</ul>
							</li>
							<li><b>x &lt;= y</b>
								<ul>
									<li style="font-size: 24px;">if x is less or equal to y, return True</li>
								</ul>
							</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Comparison Examples:</h3>
						<pre>
							<code data-trim data-noescape>
								a=7
								b=4
		
								print('a &gt; b is',a&gt;b)
		
								print('a &lt; b is',a&lt;b)
		
								print('a == b is',a==b)
		
								print('a != b is',a!=b)
		
								print('a &gt;= b is',a&gt;=b)
		
								print('a &lt;= b is',a&lt;=b)
		
		
								#Output
								a &gt; b is True
								a &lt; b is False
								a == b is False
								a != b is True
								a &gt;= b is True
								a &lt;= b is False
							</code>
						</pre>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Membership Operators</h3>
						<ul>
							<li><b>in</b>
								<ul>
									<li>Evaluates to True if it finds a variable in the checked sequence</li>
								</ul>
							</li>
							<li><b>not in</b>
								<ul>
									<li>Evaluates to True if it does not find a variable in the checked sequence</li>
								</ul>
							</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Identity Operators</h3>
						<ul>
							<li><b>is</b>
								<ul>
									<li>Evaluates to True if variables on either side of the operator point to the same object</li>
								</ul>
							</li>
							<li><b>is not</b>
								<ul>
									<li>Evaluates to True if the variables on either side of the operator does not point to the same object</li>
								</ul>
							</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Boolean Operators</h3>
						<ul>
							<li><b>and</b>
								<ul>
									<li>Evaluates True if expressions on both sides of the operator are True.</li>
								</ul>
							</li>
							<li><b>or</b>
								<ul>
									<li>Evaluates True if expressions on either side of the operator are True.</li>
								</ul>
							</li>
						</ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Operator Examples</h4>
						<pre>
							<code data-trim data-noescape>
								# Example using bitwise operators
								a=7
								b=4

								# Result: a and b is 4
								print('a and b is',a and b)

								# Result: a or b is 7
								print('a or b is',a or b)

								# Result: not a is False
								print('not a is',not a)

								#Output
								a and b is 4
								a or b is 7
								not a is False



								# Example using 'in' operator
								list1=[1,2,3,4,5]
								list2=[6,7,8,9]
								for item in list1:
									if item in list2:
										print("overlapping")      
								else:
									print("not overlapping")

								# Output: not overlapping


								# Example of 'is' identity operator
								x = 5
								if (type(x) is int):
									print ("true")
								else:
									print ("false")

								# Output: true
							</code>
						</pre>
					</section>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h4>Assignment Operators</h4>
					<table>
						<tr>
							<th>Operator</th>
							<th>Example</th>
							<th>Similar</th>
						</tr>
						<tr style="font-size: 24px;">
							<td>=</td>
							<td>x = 8</td>
							<td style="text-align: center;">x = 8</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>+=</td>
							<td>x += 8</td>
							<td style="text-align: center;">x = x + 8</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>-=</td>
							<td>x -= 8</td>
							<td style="text-align: center;">x = x - 8</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>*=</td>
							<td>x *= 8</td>
							<td style="text-align: center;">x = x * 8</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>/=</td>
							<td>x /= 8</td>
							<td style="text-align: center;">x = x/8</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>%=</td>
							<td>x %= 8</td>
							<td style="text-align: center;">x = x%8</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>**=</td>
							<td>x **= 8</td>
							<td style="text-align: center;">x = x**8</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>&=</td>
							<td>x &= 8</td>
							<td style="text-align: center;">x = x & 8</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>|=</td>
							<td>x |= 8</td>
							<td style="text-align: center;">x = x|8</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>^=</td>
							<td>x ^= 8</td>
							<td style="text-align: center;">x = x ^ 8</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>&lt;&lt;=</td>
							<td>x &lt;&lt;= 8</td>
							<td style="text-align: center;">x = x &lt;&lt; 8</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>>>=</td>
							<td>x >>= 8</td>
							<td style="text-align: center;">x = x >> 8</td>
						</tr>
					</table>
				</section>

				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>I/O Print</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Python 2 Basic</h4>
						<pre>
							<code data-trim data-noescape>
								print "hello" # print statement only valid in Py2
								print 1+1
								print 'Hello' + 'world'
								print('Hello' , 'World') # print function valid in both Py2 and Py3 (use this)

								# Printing without newline, still has space seperating though
								print "First statement ",
								print "%s" % ("Second statement"),
								print "Third statement"
								# Output: 'First statement Second statement Third statement'
							</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Python 3 Basic</h4>
						<pre>
							<code data-trim data-noescape>
								print("hello")
								print(1+1)
								print('Hello' + 'World')
								print('Hello' , 'World')

								# Printing without newline
								print("First statement ", end=" ")
								print("{}".format("Second statement"), end="")
								print("Third statement")
								# Output: 'First statement  Second statementThird statement'
							</code>
						</pre>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>% Formatting</h3>
						<p>% formatting follows C style and is being phased out. It is highly recommend to use .format()… but have practice with both!</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>% Formatting Examples</h3>
						<pre>
							<code data-trim data-noescape>
								​# Basic Positional Formatting
								print "%s World!" % "Hello"
								'Hello World!'

								# Basic Positional Formatting
								print "%s %s!" % ("Hello", "World")
								'Hello World!'

								# Padding 10 left
								print '%10s' % ('test',)
								'      test'

								# Negative Padding (10 right)
								print '%-10s %s' % ('test', 'next word')
								'test       next word'

								# Truncating Long Strings
								print '%.5s' % ('what in the world',)
								'what '

								# Truncating and padding
								print '%10.5s' % ('what in the world',)
								'     what'

								# Numbers
								print '%d' % (50,)
								50

								# Floats
								print '%f' % (3.123513423532432)
								3.123513

								# Padding numbers
								print '%4d' % (50,)
								50

								# Padding Floating Points/precision
								print '%06.2f' % (3.141592653589793,)
								003.14

								# Name Placeholders
								things = {'car': 'BMW E30', 'motorcycle': 'Harley FXDX'}
								print 'My fav car %(car)s and motorcycle %(motorcycle)s' % things
								'My fav car BMW E30 and motorcycle Harley FXDX'
							</code>
						</pre>
					</section>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h3>.format()</h3>
					<p>
                        Format strings contain "replacement fields" surrounded by curly braces {}.  Anything that is not contained in braces is considered literal text.
					</p>
					<pre>
						<code data-trim data-noescape>
							"The sum of 4 + 5 is {}".format(4 + 5)
						</code>
					</pre>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h4>.format() examples</h4>
					<pre>
						<code data-trim data-noescape>
							​# Basic Positional Formatting
							print('{} {}!'.format('Hello', 'World'))
							'Hello World!'

							# Basic Positional Formatting
							print("{!s} {!s}".format("Hello", "World"))
							'Hello World!'

							# Actual Positional Formatting
							# EXCLUSIVE
							print('{1} {0}!'.format('World', 'Hello'))
							'Hello World!'

							# Padding 10 left
							print('{:>10}'.format('test'))
							'      test'

							# Negative Padding 10 right
							print('{:<10}'.format('test'))
							'test      '

							# Changing Padding Character
							# EXCLUSIVE
							print('{:_>10}'.format('test'))
							'______test'

							# Center Align
							# EXCLUSIVE
							print('{:_^10}'.format('test'))
							'___test___'

							# Truncating Long Strings
							print('{:.5}'.format('what in the world'))
							'what '

							# Truncating and padding
							print('{:10.5}'.format('what in the world'))
							'     what'

							# Numbers
							print('{:d}'.format(50))
							50

							# Floats
							print('{:f}'.format(3.123513423532432))
							3.123513

							# Padding numbers
							print('{:4d}'.format(50))
							50

							# Padding Floating Points/precision
							print('{:06.2f}'.format(3.141592653589793))
							003.14

							# Name Placeholders
							things = {'car': 'BMW E30', 'motorcycle': 'Harley FXDX'}
							print('My favorite car is a {car} and motorcycle {motorcycle}'.format(**things))
							'My fav car BMW E30 and motorcycle Harley FXDX'


							# Date and Time
							# EXCLUSIVE
							from datetime import datetime
							print('{:%Y-%m-%d %H:%M}'.format(datetime(2017, 10, 17, 10, 45)))
							2017-10-17 10:45


							#Variables
							nBalloons = 8
							print("Sammy has {} balloons today!".format(nBalloons))

							Output
							Sammy has 8 balloons today!


							sammy = "Sammy has {} balloons today!"
							nBalloons = 8
							print(sammy.format(nBalloons))

							Output
							Sammy has 8 balloons today!

						</code>
					</pre>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h4>Format Symbols</h4>
					<table>
						<tr>
							<th>Format Symbol</th>
							<th>Conversion</th>
						</tr>
						<tr style="font-size: 24px;">
							<td>%c</td>
							<td>character</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>%s</td>
							<td>string conversion via str() prior to formatting</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>%i</td>
							<td>signed decimal integer</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>%d</td>
							<td>signed decimal integer</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>%u</td>
							<td>unsigned decimal integer</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>%o</td>
							<td>octal integer</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>%x</td>
							<td>hexadecimal integer (lowercase letters)</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>%e</td>
							<td>exponent notation</td>
						</tr>
						<tr style="font-size: 24px;">
							<td>%f</td>
							<td>floating point real number</td>
					</table>
				</section>
                
                <!-- TRANSITION -->
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h2>I/O Print Labs</h2> 
					<a href="lab3a.html">Lab 3A</a>
				</section>
				<!-- TRANSITION -->

                <section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h1>I/O Files</h1>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>I/O Files</h4>
						<p>Python offers a robust and insanely easy to use toolset to interact with files.</p>
						<p>
							First, a file must be opened before it can be modified... this includes creating new files. We use the open() function to achieve this. 
							The first argument passed is the file name; rather it exists or not. The second argument is the operation in which we would like to perform. ex read, write, overwrite, etc.
						</p>
						<pre>
							<code data-trim data-noescape>
								file = open("file.txt", 'r')
							</code>
						</pre>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>open() Operation Arguments</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>read</h3>
						<ul>
							<li><b>r</b> -- Opens file for read only. File pointer is placed at start of file.</li>
							<li><b>rb</b> -- Opens a file for reading only in binary format. The file pointer is placed at the start of the file.</li>
							<li><b>r+</b> -- Opens a file for both reading and writing. File pointer is placed at the start of the file.</li>
							<li><b>rb+</b> -- Opens a file for both reading and writing in binary format. File pointer is placed at the start of the file.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>write</h3>
						<ul>
							<li><b>w</b> -- Opens a file for writing only. Overwrites the file if it exists. If the file does not exist, it creates a new one.</li>
							<li><b>wb</b> -- Opens a file for writing only in binary format. Overwrites the file if it exists. If it does not exist, it creates a new one.</li>
                        </ul>
                    </section>
                    <section>
                        <h3>write (cont.)</h3>
                        <ul>
                            <li><b>w+</b> -- Opens a file for writing and reading. Overwrites the existing file if it exists. If it does not exist, it creates a new one.</li>
							<li><b>wb+</b> -- Opens a file for writing and reading in binary format. Overwrites the existing file if it exists. If not, it creates a new one.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>append</h3>
						<ul>
							<li><b>a</b> -- Opens a file for appending. File pointer is at end of file if it exists. If the file does not exist, it creates a new one</li>
							<li><b>ab</b> -- Opens a file for appending in binary format. File pointer is at end of file if it exists. If not, it creates a new one.</li>
                        </ul>
                    </section>
                    <section>
                        <h3>append (cont.)</h3>
                        <ul>
                            <li><b>a+</b> -- Opens a file for both appending and reading. If file exists, file pointer placed at end of file. If not, it creates a new one.</li>
							<li><b>ab+</b> -- Opens a file for both appending and reading in binary format. Follows above file pointer and write rules.</li>
						</ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Binary Formatting</h3>
                        <ul>
                            <li>binary formatting primarily apply to Windows</li>
                            <li>Windows treats binaries and files differently</li>
                            <li>reading binary in text mode in Windows will more than likely result in corrupted data.</li> 
                            <li>Passing a 'b' variant will mitigate this issue</li>
                        </ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>File Operations</h3>
						<p>
							Once the file is open, we can begin reading, adding or modifying the file's contents. Below are some of the methods to make that happen.
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>File Operations</h4>
						<ul>
							<li style="font-size: 30px;"><b>f.write(str)</b>
								<ul>
									<li style="font-size: 24px;">write str to file​</li>
								</ul>
							</li>
							<li style="font-size: 30px;"><b>f.writelines(str)</b>
								<ul>
									<li style="font-size: 24px;">write str to file​</li>
								</ul>
							</li>
							<li style="font-size: 30px;"><b>f.read(sz)</b>
								<ul>
									<li style="font-size: 24px;">read size amount​​</li>
								</ul>
							</li>
							<li style="font-size: 30px;"><b>f.readline()</b>
								<ul>
									<li style="font-size: 24px;">read next line​​</li>
								</ul>
							</li>
							<li style="font-size: 30px;"><b>f.seek(offset)</b>
								<ul>
									<li style="font-size: 24px;">move file pointer to offset​​</li>
								</ul>
							</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>File Operations</h4>
						<ul>
							<li style="font-size: 30px;"><b>f.tell()</b>
								<ul>
									<li style="font-size: 24px;">current file position​</li>
								</ul>
							</li>
							<li style="font-size: 30px;"><b>f.truncate(sz)</b>
								<ul>
									<li style="font-size: 24px;">truncate the files z bytes​​</li>
								</ul>
							</li>
							<li style="font-size: 30px;"><b>f.mode()</b>
								<ul>
									<li style="font-size: 24px;">returns the access mode used to open a file​</li>
								</ul>
							</li>
							<li style="font-size: 30px;"><b>f.name()</b>
								<ul>
									<li style="font-size: 24px;">returns the name of a file​</li>
								</ul>
							</li>
							<li style="font-size: 30px;"><b>f.close()</b>
								<ul>
									<li style="font-size: 24px;">close file handle​...​</li>
									<li style="font-size: 24px;">Just like other programming languages, we need to close the stream​</li>
									<li style="font-size: 24px;"><b>ALWAYS CLOSE THE FILE AS SOON AS YOU'RE FINISHED USING IT!!</b>​</li>
								</ul>
							</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>File Operations Examples</h3>
						<pre>
							<code data-trim data-noescape>
								f = open('file_name', 'a')
								data = f.read()
								print data

								file.close()
							</code>
						</pre>
					</section>
				</section>

				<!-- TRANSITION -->
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h2>I/O Files Lab</h2>
					<a href="lab3b.html">Lab 3B</a>
				</section>
				<!-- TRANSITION -->

				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>If, Elif, Else</h2>
                        <ul>
                            <li>Python includes the standard if, else-if, and else statements</li>
                            <li>Python's else-if statement is shortened to elif</li>
                        </ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>If, Elif, Else</h2>
						<ul>
                            <li>
                                Python has a standard if, else statement
                                <ul>
                                    <li>The if statement checks for truth within a given condition</li>
                                    <li>If the condition is false, the code within the if statement will not run</li>
                                    <li>To counter this, you can use elif statements to check for further conditions</li>
                                    <li>The else statement which is a catch all if none of the previous statements evaluate to True</li>
                                </ul>
                            </li>
						</ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>If, Elif, Else example</h3>
                        <!--
                            Great Instructor Note
                        <p>
							As mentioned in previous lectures, Python does not use brackets. So unlike C, Java, etc... Python uses indentation. To make this work for statements, loops, functions, etc... Python uses a colon ':' to declare the start of an indented block.
                        </p>
                        -->
						<pre>
							<code data-trim data-noescape>
								a = 100
								if a > 100:
									print('a is greater than 100')
								elif a < 100:
									print('a is less than 100')
								else:
								print('a is equal to 100')
							</code>
						</pre>
						<h4>Output</h4>
						<pre>
							<code data-trim data-noescape>
								a is equal to 100
							</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Another Example</h4>
						<p>
							What is the output?
						</p>
						<pre>
							<code data-trim data-noescape>
								for a in range(51):
								if a == 0:
									print("{} you can't divide by zero!".format(a))
								elif a % 10 == 0:
									print ('{} can be divided by 10!!!'.format(a))
								elif a % 2 == 0:
									print('{} is even!'.format(a))
								else:
									print('{} is odd!'.format(a))

							</code>
						</pre>
					</section>
				</section>

				<!-- TRANSITION -->
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h2>If, Elif, Else Labs</h2> 
					<a href="https://39iosdev.gitlab.io/ccd-iqt/idf/python/Flow_Control/lab3c.html">Lab 3C</a>
				</section>
				<!-- TRANSITION -->

				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>While Loops</h2>
                        <p>While loops, just like C and C++, loop through each iteration until either the condition is met or a break statement is called.</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>While Loops Example</h3>
						<pre>
							<code data-trim data-noescape>
								count = 0
								while count < 5:
									print('count: ' + str(count))
									count += 1
							</code>
                        </pre>
                        <h4>Output</h4>
						<pre>
							<code data-trim data-noescape>
								count: 0
								count: 1
								count: 2
								count: 3
								count: 4
							</code>
						</pre>
                    </section>
                    <!--
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 24px; text-align: left;">
							When using the while loop, a few factors will make a difference in the output... that could break your program if you don't pay attention. The value of the incrementing var, 
							where the count increment is placed and the comparison operator are the three most common factors. Here are a few things to keep in mind:
						</p>
						<ul>
							<li style="font-size: 24px;">It's common practice to increment your var after the bulk of the code is executed (count += 1)</li>
							<li style="font-size: 24px;">With that said, setting the count equal to 0 will start the output at 0, 1 will start at 1... etc</li>
							<li style="font-size: 24px;">
								It's best practice to change the comparison operator rather than the 'increment to number'. For instance, count is currently set to increment until 10. Since the code increments after the print is executed... the last count printed is 9, even though the count really ends on 10. 
								If you follow the above factors, changing the comparison operator to <= will result in an output that prints count: 10 without effecting code that relies on count.
							</li>
						</ul>
                    </section>
                    -->
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>While Else</h2>
                        <p>The while-else runs like a regular while loop except for the one iteration when the while loop becomes false. This results in the else statement being executed once!</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>While Else</h3>
						<pre>
							<code data-trim data-noescape>
								count = 0
								while count <= 4:
									print('count: {}'.format(count))
									count += 1
								else:
									print('while loop executed... count is: {}'.format(count))
							</code>
						</pre>
					    <h4>Output</h4>
						<pre>
							<code data-trim data-noescape>
								count: 0
								count: 1
								count: 2
								count: 3
								count: 4
								while loop executed... count is: 5
							</code>
						</pre>
						<div>This gives us a clearer look at how Python increments variables.</div>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 24px; text-align: left;">
							When using the while loop, a few factors will make a difference in the output... that could break your program if you don't pay attention. The value of the incrementing var, 
							where the count increment is placed and the comparison operator are the three most common factors. Here are a few things to keep in mind:
						</p>
					</section>
				</section>

				<!-- TRANSITION -->
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h2>While Loops Lab</h2> 
					<a href="lab3d.html">Lab 3D</a>
				</section>
				<!-- TRANSITION -->

				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>For Loops</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>For Loop in C</h3>
						<pre>
							<code data-trim data-noescape>
								char *my_string = "Python";
								for (int i = 0; i < strlen(my_string); i++) {
									printf(%c\n", my_string[i]);
								}

							</code>
						</pre>
					    <h3>Python in C Style:</h3>
						<pre>
							<code data-trim data-noescape>
								my_string = "Python"
								for i in range(len(my_string)):
									print(my_string[i])
							</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Python For loop</h3>
						<pre>
							<code data-trim data-noescape>
								my_string = "Python"
								for letter in my_string:
									print(letter)
							</code>
                        </pre>
                        <ul>
                            <li>Strings are iterable </li>
                            <li>The "in" operator simply calculates the count of my_string and iterates through it as var letter</li>
                            <li>The value of letter is my_string[i]</li>
                        </ul>
					</section>
                </section>
                <section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h3>For Looping Dictionaries</h3>
                        <p>One way to set up looping for a dictionary</p>
                        <pre>
                            <code data-trim data-noescape>
                                #In python 2 use the method iteritems()
                                for key, value in dict.iteritems():
                                    pass
                            </code>
                        </pre>
                        <pre>
                            <code data-trim data-noescape>
                                #In python 3 the method is now just items()
                                for key, value in dict.items():
                                    pass
    
                            </code>
                        </pre>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <p>Here is an example of how to do this</p>
                        <pre>
                            <code data-trim data-noescape>
                                x = {'stu1':'James', 'stu2':'Bob', 'stu3':'Rengar'}
    
                                for stu_id, name in x.items():
                                    print("{}'s name is {}".format(stu_id, name))
                            </code>
                        </pre>
                    </section>
                </section>
                <section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h3>Loops: Iterative vs Recursive</h3>
                        <ul>
                            <li>Iteration and recursion each involve a termination test: 
                                <ul>
                                    <li>Iteration terminates when the loop-continuation condition fails</li>
                                    <li>recursion terminates when a base case is recognized</li>
                                </ul>
							</li>
						</ul>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <ul>
                            <li>Iteration
                                <ul>
                                    <li>When a loop repeatedly executes until the controlling condition becomes false.</li>
                                </ul>
                            </li>
                            <li>Recursion
                                <ul>
                                    <li>When a statement in a function calls itself repeatedly.</li>
                                </ul>
                            </li>
                        </ul>
                    </section>
                </section>

				<!-- TRANSITION -->
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h2>For Loops Lab</h2> 
					<a href="lab3e.html">Lab 3e</a>
				</section>
				<!-- TRANSITION -->

				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Break and Continue</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Break</h4>
						<p>
							The break statement simply breaks out of the innermost enclosing loop.
						</p>
						<pre>
							<code data-trim data-noescape>
								for i in range(1, 101):
									if i == 10:
										print("WE BROKE IT!")
										break
									print(i)
							</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Output:</h4>
						<pre>
							<code data-trim data-noescape>
								1
								2
								3
								4
								5
								6
								7
								8
								9
								WE BROKE IT!
							</code>
                        </pre>
                        <!-- Instructor Note?
                            <p>While the Python one certainly is shorter and looks cleaner... it's still not Pythonic for our use. Though, there will be times where range(len()) formula is useful... mostly when dealing with mutable types.</p>
                        -->
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Continue</h4>
						<p>
							The continue statement continues with the next iteration of the loop.
						</p>
						<pre>
							<code data-trim data-noescape>
								for i in range(1, 100):​
									if i % 2 == 0:​
										print("{} is an even number!".format(i)​)
										continue #prevents second print from running​
									print("{} is an odd number!".format(i))

							</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Output:</h4>
						<pre>
							<code data-trim data-noescape>
								1 is an odd number!
								2 is an even number!
								3 is an odd number!
								4 is an even number!
								5 is an odd number!
								6 is an even number!
								7 is an odd number!
								8 is an even number!
								9 is an odd number!
								10 is an even number!
								11 is an odd number!
								12 is an even number!
								13 is an odd number!
								14 is an even number!
								15 is an odd number!
								16 is an even number!
								17 is an odd number!
								18 is an even number!
								19 is an odd number!
								20 is an even number!
								....								
							</code>
						</pre>
					</section>
				</section>

				<!-- TRANSITION -->
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h2>Break and Continue Lab</h2> 
					<a href="lab3f.html">Lab 3f</a>
				</section>
				<!-- TRANSITION -->
                <section>
                    <h2>Questions?</h2>
                </section>
                <section>
                    <section>
                        <h2>Summary</h2>
                        <ul>
                            <li>Operators</li>
                            <li>I/O Print</li>
                            <li>I/O Files</li>
                            <li>If, Elif, Else</li>
                            <li>While Loops</li>
                            <li>For Loops</li>
                            <li>Break and Continue</li>
                        </ul>
                    </section>
                </section>
			</div>
		</div>
		<footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>		
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

					// If slides do not have a matching title, attempt to use the
					// start of the text content as the title instead
					useTextContentForMissingTitles: false,

					// Hide slides from the menu that do not have a title.
					// Set to 'true' to only list slides with titles.
					hideMissingTitles: false,

					// Adds markers to the slide titles to indicate the 
					// progress through the presentation. Set to 'false'
					// to hide the markers.
					markers: true,

					// Specify custom panels to be included in the menu, by
					// providing an array of objects with 'title', 'icon'
					// properties, and either a 'src' or 'content' property.
					custom: false,

					// Specifies the themes that will be available in the themes
					// menu panel. Set to 'true' to show the themes menu panel
					// with the default themes list. Alternatively, provide an
					// array to specify the themes to make available in the
					// themes menu panel, for example...
					// [
					//     { name: 'Black', theme: 'css/theme/black.css' },
					//     { name: 'White', theme: 'css/theme/white.css' },
					//     { name: 'League', theme: 'css/theme/league.css' }
					// ]
					themes: true,

					// Specifies the path to the default theme files. If your
					// presentation uses a different path to the standard reveal
					// layout then you need to provide this option, but only
					// when 'themes' is set to 'true'. If you provide your own 
					// list of themes or 'themes' is set to 'false' the 
					// 'themesPath' option is ignored.
					themesPath: 'css/theme/',

					// Specifies if the transitions menu panel will be shown.
					// Set to 'true' to show the transitions menu panel with
					// the default transitions list. Alternatively, provide an
					// array to specify the transitions to make available in
					// the transitions panel, for example...
					// ['None', 'Fade', 'Slide']
					transitions: true,

					// Adds a menu button to the slides to open the menu panel.
					// Set to 'false' to hide the button.
					openButton: true,

					// If 'true' allows the slide number in the presentation to
					// open the menu panel. The reveal.js slideNumber option must 
					// be displayed for this to take effect
					openSlideNumber: true,

					// If true allows the user to open and navigate the menu using
					// the keyboard. Standard keyboard interaction with reveal
					// will be disabled while the menu is open.
					keyboard: true,

					// Normally the menu will close on user actions such as
					// selecting a menu item, or clicking the presentation area.
					// If 'true', the sticky option will leave the menu open
					// until it is explicitly closed, that is, using the close
					// button or pressing the ESC or m key (when the keyboard 
					// interaction option is enabled).
					sticky: true,

					// If 'true' standard menu items will be automatically opened
					// when navigating using the keyboard. Note: this only takes 
					// effect when both the 'keyboard' and 'sticky' options are enabled.
					autoOpen: true,

					// If 'true' the menu will not be created until it is explicitly
					// requested by calling RevealMenu.init(). Note this will delay
					// the creation of all menu panels, including custom panels, and
					// the menu button.
					delayInit: false,

					// If 'true' the menu will be shown when the menu is initialised.
					openOnInit: false,

					// By default the menu will load it's own font-awesome library
					// icons. If your presentation needs to load a different
					// font-awesome library the 'loadIcons' option can be set to false
					// and the menu will not attempt to load the font-awesome library.
					loadIcons: true
				},
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/highlight/highlight.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/reveal.js-menu/menu.js' }
				]
			});
		</script>
	</body>
</html>
